<?php
namespace App\Traits;
use DB;
use Illuminate\Support\Facades\Auth;
trait Transaction{

    public function refundToAccount($userid, $companyid, $price, $qty){
        try {
           \App\Accounts::
            where('user_id', '=', $userid)
                ->where('company_id', '=', $companyid)
                ->increment('point', $price * $qty);
            return true;
        } catch (\Exception $e) {
            return false;
        }
    }

    public function refundToAccountPlusDelivery($orderid, $vouchers, $delivery_cost, $cancelreason){
        $transby = [];
        $transby['user_id'] = null;
        $transby['name'] = "admin";
        $transby['user_email'] = null;
        $transby['company_id'] = null;
        $reason = null;

        if(isset($cancelreason)){
            $reason = $cancelreason;
        }

        $order = \App\Order::where('order_no', $orderid)->select('user_id', 'company_id')->first();

        $cart = \App\Cart::
        where('user_id', '=', $order->user_id)
            ->where('company_id', '=', $order->company_id)
            ->whereIn('voucher', $vouchers)
            ->select(DB::raw('sum(price*qty) as totalprice'))
            ->first();

        $refundcost = ($cart->totalprice + $delivery_cost);
        $user_data = \App\User::where('id', $order->user_id)->select('email', 'id', 'company_id')->first();
        $currency = $this->currency($order->company_id);

        try {
           \App\Accounts::
            where('user_id', '=', $user_data->id)
                ->where('company_id', '=', $user_data->company_id)
                ->increment('point', $refundcost);


            $balance =  \App\Accounts::where([
                ['user_id', '=', $user_data->id],
                ['company_id', '=', $user_data->company_id ],
            ])->select('point')->first();

            $transaction = new \App\Transaction();
            $transaction->type = $this->transtype['credit'];
            $transaction->type_name = array_keys($this->transtype)[1];
            $transaction->is_internal_action = $this->is_internal_action['external'];
            $transaction->is_internal_action_name = array_keys($this->is_internal_action)[0];
            $transaction->order_id = $orderid;
            $transaction->point_raw = $refundcost;
            $transaction->balance_raw = $balance->point;
            $transaction->balance_virtual = $balance->point * (!$currency->is_currency_fixed ? $currency->rate : 1);
            $transaction->company_id = $user_data->company_id;
            $transaction->member_id = $user_data->id;
            $transaction->point_virtual = $refundcost * (!$currency->is_currency_fixed ? $currency->rate : 1);
            $transaction->reason = $reason;
            $transaction->trans_by = json_encode($transby);
            $transaction->save();

//            $refundtotal = $refundcost * (!$currency->is_currency_fixed ? $currency->rate : 1);
//            $newbalance = $balance->point * (!$currency->is_currency_fixed ? $currency->rate : 1);

            if ($currency->is_currency_fixed  == '1'){
                $refundtotal = "&#8358 " .number_format($refundcost, 0, '.', ',');
                $newbalance  = "&#8358 " .number_format($balance->point, 0, '.', ',');
            }
            else
            {
                $refundtotal =  number_format( ($currency->rate * $refundcost), 0, '.', ',');
                $newbalance  =  number_format(($currency->rate * $balance->point), 0, '.', ',') . ' ' . $currency->currency;
            }

            return $response = ['status' => true, 'refund_amount' => $refundtotal, 'balance' => $newbalance];
        } catch (\Exception $e) {
            return $response = ['status' => false, 'message' => $e->getMessage() . '\n' . $e->getTraceAsString() . '\n' . $e->getLine()];
        }
    }

    public function refundToAccountWithoutDelivery($orderid, $vouchers){
        $transby = [];
        $transby['user_id'] = null;
        $transby['name'] = "admin";
        $transby['user_email'] = null;
        $transby['company_id'] = null;
        $reason = null;

        $order = \App\Order::where('order_no', $orderid)->select('user_id', 'company_id')->first();

        $cart = \App\Cart::
            where('user_id', '=', $order->user_id)
            ->where('company_id', '=', $order->company_id)
            ->whereIn('voucher', $vouchers)
            ->select(DB::raw('sum(price*qty) as totalprice'))
            ->first();

//            ->select(DB::raw('sum(price*qty) as totalprice'))
//            ->pluck('totalprice');
//        $voucher_data = \App\Cart::whereIn('voucher', $vouchers)->select('user_id')->first();

        $refundcost = floatval($cart->totalprice);
        $user_data = \App\User::where('id',$order->user_id)->select('email', 'id', 'company_id')->first();
        $currency = $this->currency($order->company_id);

        try {
           \App\Accounts::
            where('user_id', '=', $user_data->id)
                ->where('company_id', '=', $user_data->company_id)
                ->increment('point', $refundcost);

            $balance =  \App\Accounts::where([
                ['user_id', '=', $user_data->id],
                ['company_id', '=', $user_data->company_id ],
            ])->select('point')->first();

            $transaction = new \App\Transaction();
            $transaction->type = $this->transtype['credit'];
            $transaction->type_name = array_keys($this->transtype)[1];
            $transaction->is_internal_action = $this->is_internal_action['external'];
            $transaction->is_internal_action_name = array_keys($this->is_internal_action)[0];
            $transaction->order_id = $orderid;
            $transaction->point_raw = $refundcost;
            $transaction->balance_raw = $balance->point;
            $transaction->balance_virtual = $balance->point * (!$currency->is_currency_fixed ? $currency->rate : 1);
            $transaction->company_id = $user_data->company_id;
            $transaction->member_id = $user_data->id;
            $transaction->point_virtual = $refundcost * (!$currency->is_currency_fixed ? $currency->rate : 1);
            $transaction->reason = $reason;
            $transaction->trans_by = json_encode($transby);
            $transaction->save();

            if ($currency->is_currency_fixed  == '1'){
                $refundtotal = "&#8358 " .number_format($refundcost, 0, '.', ',');
                $newbalance  = "&#8358 " .number_format($balance->point, 0, '.', ',');
            }
            else
            {
                $refundtotal =  number_format( ($currency->rate * $refundcost), 0, '.', ',');
                $newbalance  =  number_format(($currency->rate * $balance->point), 0, '.', ',') . ' ' . $currency->currency;
            }
            return $response = ['status' => true, 'refund_amount' => $refundtotal, 'balance' => $newbalance];
        } catch (\Exception $e) {
            return $response = ['status' => false, 'message' => $e->getMessage()];
        }
    }
    
    public function completependingAccount($user_id, $name,$qty,$price, $company_id, $ref_no, $voucher_code, $order_no)
    {
        
        $get_details = $this->getUserdetails($user_id,$company_id);
        
        if ($get_details['status']){
        $transby = [];
        $transby['user_id'] = $user_id;
        $transby['name'] = $get_details['name'];
        $transby['user_email'] = $get_details['email'];
        $transby['company_id'] = $company_id;
        $transby = json_encode($transby);
        $cost_amount = floatval($qty * $price);
        $currency = $this->currency($company_id);
        $reason = null;
    
            $balance = $this->getUserBalance($user_id, $company_id);
            if($balance['status']){
    
                $new_balance = $balance['balance'];
    
                $create_order = $this->createOrder($user_id, $company_id,$cost_amount, $ref_no, $voucher_code, $order_no);
                if ($create_order['status']){
    
                    $create_transaction = $this->createTransaction(0,$create_order['id'],$user_id, $cost_amount, $new_balance, $company_id, $reason, $transby,$currency);
                    //dd($create_transaction);
                    if($create_transaction['status']){
    
                        return $create_transaction;
                    } else {
    
                        return $response = ['status' => false, 'message' => 'Error inserting transaction'];
                    }
    
                } else {
    
                    return $response = ['status' => false, 'message' => 'Error inserting Order'];
                }
            } else {
    
                return $response = ['status' => false, 'message' => 'Error getting balance'];
            }
    
        } else {
    
            return $get_details;
        }
    }
    
    public function refundpendingAccount($user_id, $name,$qty,$price, $company_id, $ref_no, $voucher_code, $order_no)
    {
        $transby = [];
        $transby['user_id'] = null;
        $transby['name'] = "admin";
        $transby['user_email'] = null;
        $transby['company_id'] = null;
        $transby = json_encode($transby);
        $reason = 'Refund Failed Transaction ( '.$name.' )';
    
        $refund_amount = floatval($qty * $price);
        $currency = $this->currency($company_id);
        $refund_cost = $this->refundToAccount($user_id, $company_id, $price, $qty);
    
        if($refund_cost){
    
            $balance = $this->getUserBalance($user_id, $company_id);
    
            if($balance['status']){
    
                $new_balance = $balance['balance'];
    
                $create_order = $this->createOrder($user_id, $company_id,$refund_amount, $ref_no, $voucher_code, $order_no);
                if ($create_order['status']){
    
                    $create_transaction = $this->createTransaction(1,$create_order['id'],$user_id, $refund_amount, $new_balance, $company_id, $reason, $transby,$currency);
                    //dd($create_transaction);
                    if($create_transaction['status']){
    
                        return $create_transaction;
                    } else {
    
                        return $response = ['status' => false, 'message' => 'Error inserting transaction'];
                    }
    
                } else {
    
                    return $response = ['status' => false, 'message' => 'Error inserting Order'];
                }
            } else {
    
                return $response = ['status' => false, 'message' => 'Error getting balance'];
            }
        } else {
    
            return $response = ['status' => false, 'message' => 'Error refunding price'];
        }
    
    }
    
    private function getUserBalance ($user_id, $company_id){
        $balance =  \App\Accounts::where([
            ['user_id', '=', $user_id],
            ['company_id', '=', $company_id ],
        ])->select('point')->first();
        if ($balance){
    
            return $response = ['status' => true, 'balance' => $balance['point']];
        } else {
    
            return $response = ['status' => false, 'message' => 'Error getting balance'];
        }
    }
    
    private function getUserdetails ($user_id, $company_id){
        
        $details =  \App\User::where([
            ['id', '=', $user_id],
            ['company_id', '=', $company_id ],
        ])->select('name', 'email')->first();
    
        if ($details){
    
            return $response = ['status' => true, 'name' => $details['name'], 'email' => $details['email']];
        } else {
    
            return $response = ['status' => false, 'message' => 'Error getting details'];
        }
    }
    
    private function createTransaction($type, $orderid, $user_id,$refundcost, $balance, $company_id, $reason, $transby, $currency)
    {
        if ($type == 1 || $type == 0) {
            try{
            $transaction = new \App\Transaction();
            if ($type == 1) {
                $transaction->type = $this->transtype['credit'];
                $transaction->type_name = array_keys($this->transtype)[1];
                $transaction->is_internal_action = $this->is_internal_action['external'];
                $transaction->is_internal_action_name = array_keys($this->is_internal_action)[0];
            } elseif ($type == 0) {
                $transaction->type = $this->transtype['debit'];
                $transaction->type_name = array_keys($this->transtype)[0];
                $transaction->is_internal_action = $this->is_internal_action['external'];
                $transaction->is_internal_action_name = array_keys($this->is_internal_action)[0];
    
            }
    
            $transaction->order_id = $orderid;
            $transaction->point_raw = $refundcost;
            $transaction->balance_raw = $balance;
            $transaction->balance_virtual = $balance * (!$currency->is_currency_fixed ? $currency->rate : 1);
            $transaction->company_id = $company_id;
            $transaction->member_id = $user_id;
            $transaction->point_virtual = $refundcost * (!$currency->is_currency_fixed ? $currency->rate : 1);
            $transaction->reason = $reason;
            $transaction->trans_by = $transby;
            $transaction->save();
    
            if ($currency->is_currency_fixed  == '1'){
                $refundtotal = "&#8358 " .number_format($refundcost, 0, '.', ',');
                $newbalance  = "&#8358 " .number_format($balance, 0, '.', ',');
            }
            else
            {
                $refundtotal =  number_format( ($currency->rate * $refundcost), 0, '.', ',');
                $newbalance  =  number_format(($currency->rate * $balance), 0, '.', ',') . ' ' . $currency->currency;
            }
            return $response = ['status' => true, 'amount' => $refundtotal, 'balance' => $newbalance, 'type' => $transaction->type_name];
            } catch (\Exception $e) {
                return $response = ['status' => false, 'message' => $e->getMessage()];
            }
        } else{
    
            return $response = ['status' => false, 'message' => 'Invalid Transaction Type'];
    
        }
    
    }
    
    private function createOrder($user_id, $company_id, $total_cost, $ref_no, $voucher_code, $order_no){
        $first_array = array();
        $first_array['ref_no'] = $ref_no;
        $first_array['voucher_code'] = $voucher_code;
        $main_array = array();
        $main_array[] = $first_array;
        $fail_array = array();
        try{
        $order = new \App\Order();
        $order->user_id = $user_id;
        $order->company_id = $company_id;
        $order->address_id = null;
        $order->sub_total_cost = $total_cost;
        $order->is_shipping = 0;
        $order->shipping_cost = null;
        $order->success = $main_array;
        $order->fail = $fail_array;
        $order->order_no = $order_no;
    
        $order->save();
            return $response = ['status' => true, 'id' => $order->id];
        } catch (\Exception $e) {
            return $response = ['status' => false, 'message' => $e->getMessage()];
        }
    }

}